# CVE-2024-9935 - PDF Generator Addon for Elementor Page Builder &lt;= 1.7.5 - Unauthenticated Arbitrary File Download

[![My Shop](https://img.shields.io/badge/My%20Shop-verylazytech-%23FFDD00?style=flat&logo=buy-me-a-coffee&logoColor=yellow)](https://buymeacoffee.com/verylazytech/extras)
[![Medium](https://img.shields.io/badge/Medium-%40verylazytech-%231572B6?style=flat&logo=medium&logoColor=white)](https://medium.com/@verylazytech)
[![Github](https://img.shields.io/badge/Github-verylazytech-%23181717?style=flat&logo=github&logoColor=white)](https://github.com/verylazytech)
[![Buy Me A Coffee](https://img.shields.io/badge/Buy%20Me%20A%20Coffee-verylazytech-%23FFDD00?style=flat&logo=buy-me-a-coffee&logoColor=yellow)](https://buymeacoffee.com/verylazytech)

## Overview

The PDF Generator Addon for Elementor Page Builder plugin for WordPress is vulnerable to Path Traversal in all versions up to, and including, 1.7.5 via the rtw_pgaepb_dwnld_pdf() function. This makes it possible for unauthenticated attackers to read the contents of arbitrary files on the server, which can contain sensitive information.

# Affected Devices

- PDF Generator Addon for Elementor Page Builder <= 1.7.5

# Affected Components

This plugin is designed to generate PDFs from Elementor pages within WordPress sites. The vulnerability arises from a path traversal flaw in the rtw_pgaepb_dwnld_pdf() function, which allows unauthenticated attackers to read arbitrary files on the server, potentially exposing sensitive information.

**Read about it** — [CVE-2024-9935](https://nvd.nist.gov/vuln/detail/CVE-2024-9935)

> **Disclaimer**: This Proof of Concept (POC) is made for educational and ethical testing purposes only. Usage of this tool for attacking targets without prior mutual consent is illegal. It is the end user’s responsibility to obey all applicable local, state, and federal laws. Developers assume no liability and are not responsible for any misuse or damage caused by this program.

## Getting Started

### Finding Targets

To find potential targets, use Fofa (similar to Shodan.io):

- **Fofa Dork**: body="wp-content/plugins/pdf-generator-addon-for-elementor-page-builder/" && body="wp-content/themes/"

![image](https://github.com/user-attachments/assets/399c60ba-51b9-4d84-93e4-b138befe7981)

### Cloning the Repository

First, clone the repository:

```bash
git clone https://github.com/verylazytech/CVE-2024-9935
```

Run the Exploit:

### For Linux / MacOs:
```bash
bash ./cve-2024-9935.sh <target_url> <file_path_to_download> <action: download|view>
```

### POC:
#### View file - /etc/passwd:
![POC1](https://github.com/user-attachments/assets/d62f9e9c-5e20-4f0c-92ee-e5a608522f4a)

#### Download File - /etc/passwd:
![POC2](https://github.com/user-attachments/assets/505bfda7-ed05-402f-a251-20bbe74cf3a9)

